
{TurboPascal 7.0 Programm ***** Manfred G. Fischer, Mnster, 26.06.1995}
{(c) alle Rechte bei Manfred G. Fischer, D-48163 Mnster}
{Demoprogramm zur Loksteuerung mit Mrklin-Digital, simuliert Control80}

Program Control8;

Uses ScreenIO, BigText1, Digital;

Const x1 = 10; {Fenstergrenzen}
      x2 = x1 + 34;
      y1 = 3;
      y2 = y1 + 7;
      StopChar = EscapeKey; {Taste fr Programmstop}

Var DigitalAdresse : array[0..LokAdresseMax] of record {1. Feld[0] dient als Dummy}
      Geschwindigkeit : Vstop..Vmax; {0..14}
      Umschalten : Boolean;
      FunktionAn : Boolean;
    end;
    AktuelleAdresse : Word;
    FreigabeTaste, NotHaltTaste, NotHaltGesendet : Boolean;
    Loop : Byte; {Laufvariable}
    Ch : Char; {fr Tastaturabfrage}
    Sekunde : Word; {Zeitnahme}

Function CToB(Ch : Char) : Byte; {Char To Byte}
begin
  CToB := Ord(Ch) - Ord('0');
end;

Function BToC(B : Word) : Char; {Byte To Char}
begin
  BToC := Chr((B MOD 10) + Ord('0'));
end;

{Hauptprogramm}
begin
  {Initialisierung}
  for AktuelleAdresse := 0 to LokAdresseMax do
  with DigitalAdresse[AktuelleAdresse] do
  begin
    Geschwindigkeit := Vstop;
    Umschalten := FALSE;
    FunktionAn := FALSE;
  end;
  AktuelleAdresse := 0;
  FreigabeTaste := FALSE;
  NotHaltTaste := FALSE;
  NotHaltGesendet := FALSE;
  Ch := 'A';

  SetComPort(1);
  DigitalInterfaceInit;
  Sekunde := Sekundenzeiger;

  {Fuzeile anzeigen}
  Farben(15,3);
  LoescheZeile(25);
  write(' <0..9> Digital-Adr. <+>/<-> Geschw. <F>unktion an/aus <U>mschalten <S>top <G>o');

  {Fenster initialisieren}
  Farben(0,3);
  MakeFenster(x1,y1,x2,y2,1);
  GotoXY(x1+2,y1);
  write('Control fr ',LokAdresseMax,' Lok-Adressen');
  GotoXY(x1+2,y2);
  write('Ende mit <ESC>');
  GotoXY(x1+1,y1+5);
  write('<+><-> ');
  {Adresse anzeigen}
  Farben(15,3);
  GotoXY(x1+2,y1+2);
  WriteBiLine2x3(BToC(AktuelleAdresse DIV 10));
  WriteBiLine2x3(BToC(AktuelleAdresse MOD 10));

  repeat

    {Tastatur auswerten}

    if TastaturAktiviert then
    begin
      if ReadUpCaseKey(Ch) then {Funktionstate gedrckt};
      case Ch of
        'G' : FreigabeTaste := TRUE;
        'S' : if not NotHaltGesendet then NotHaltTaste := TRUE;
        '0'..'9' : begin
           AktuelleAdresse := (AktuelleAdresse * 10) + CToB(Ch);
           if (AktuelleAdresse > LokAdresseMax) then AktuelleAdresse := CToB(Ch);
        end;
        else if (AktuelleAdresse in [LokAdresseMin..LokAdresseMax]) then
        with DigitalAdresse[AktuelleAdresse] do
        begin
          case Ch of
            '+' : if (Geschwindigkeit < Vmax) then Inc(Geschwindigkeit);
            '-' : if (Geschwindigkeit > Vstop) then Dec(Geschwindigkeit);
            'U' : begin
                    Umschalten := TRUE;
                    Geschwindigkeit := 0;
                  end;
            'F' : FunktionAn := not FunktionAn;
          end;
        end;
      end;

      {Adresse anzeigen}
      GotoXY(x1+2,y1+2);
      WriteBiLine2x3(BToC(AktuelleAdresse DIV 10));
      WriteBiLine2x3(BToC(AktuelleAdresse MOD 10));

      {Geschwindigkeit anzeigen}
      GotoXY(x1+8,y1+5);
      write(Vstop);
      with DigitalAdresse[AktuelleAdresse] do
      begin
        for Loop := Succ(Vstop) to Geschwindigkeit do write('-');
        write(SEC2);
        for Loop := Succ(Geschwindigkeit) to Vmax do write('-');
        write(Vmax);

        {Umschaltbefehl ?}
        if Umschalten then write('<U>') else write('   ');
        if FunktionAn then write('<F>') else write('   ');
      end;

      {Nothalt und Freigabe anzeigen}
      GotoXY(x1+26,y1+3);
      if NotHaltTaste then write('<S>   ')
      else if FreigabeTaste then write('   <G>');
    end; {TastaturAktiviert}


    {Senden}

    if NotHaltTaste then
    begin
      NotHalt;
      NotHaltGesendet := TRUE;
      NotHaltTaste := FALSE;
    end
    else if FreigabeTaste then
    begin
      Freigabe;
      NotHaltGesendet := FALSE;
      FreigabeTaste := FALSE;
    end
    else if (AktuelleAdresse in [LokAdresseMin..LokAdresseMax])
    and not NotHaltGesendet then
    begin
      with DigitalAdresse[AktuelleAdresse] do
      begin
        if Umschalten then
        begin
          LokUmschalten(AktuelleAdresse,FunktionAn);
          Umschalten := FALSE;
        end
        else {regelmig Befehl wiederholen, einmal pro Sekunde}
        begin
          if (Sekunde <> Sekundenzeiger) then
          begin
            LokBefehl(AktuelleAdresse,Geschwindigkeit,FunktionAn);
            Sekunde := Sekundenzeiger;
          end;
        end;
      end;
    end;

  until (Ch = StopChar);
end.

