
{Datei: C:\Pascal\Units\BigText4.Pas *******25.08.1994***}
{TurboPascal 4.0 Unit: verwendet Routinen aus TP Unit CRT}
{ groe Schrift (aus Zeichen zusammengesetzt) im TextMode}

{(c) Manfred G. Fischer, Heroldstrae 44, D-48163 Mnster}
{letzte nderung: 25.08.94}

Unit BigText1;

Interface

Procedure WriteBiLine2x3(Ch : Char);


Implementation

Uses Crt; {fr GotoXY(), WhereX, WhereY}

Type BiLine_Char_Matrix = array[1..3 {Zeilen},1..2 {Spalten}] of Char;

Const Digit2x3 : array['0'..'9'] of BiLine_Char_Matrix =
      (((#201,#187),(#186,#186),(#200,#188)),
       ((#32,#203),(#32,#186),(#32,#202)),
       ((#201,#187),(#201,#188),(#200,#188)),
       ((#201,#187),(#32,#185),(#200,#188)),
       ((#187,#201),(#200,#185),(#32,#208)),
       ((#201,#187),(#200,#187),(#200,#188)),
       ((#201,#187),(#204,#187),(#200,#188)),
       ((#201,#187),(#32,#186),(#32,#208)),
       ((#201,#187),(#204,#185),(#200,#188)),
       ((#201,#187),(#200,#185),(#200,#188)));

Procedure WriteBiLine2x3(Ch : Char);
begin
  case Ch of
    ' ','-','+','.' :
    begin
      write(' ');
      GotoXY(WhereX-1,WhereY+1);
      case Ch of
        '-' : write(#205);
        '+' : write(#206);
        else write(' ');
      end;
      GotoXY(WhereX-1,WhereY+1);
      case Ch of
        '.' : write(#254);
        else write(' ');
      end;
      GotoXY(WhereX,WhereY-2);
    end;
    '0'..'9' :
    begin
      write(Digit2x3[Ch][1,1],Digit2x3[Ch][1,2]);
      GotoXY(WhereX-2,WhereY+1);
      write(Digit2x3[Ch][2,1],Digit2x3[Ch][2,2]);
      GotoXY(WhereX-2,WhereY+1);
      write(Digit2x3[Ch][3,1],Digit2x3[Ch][3,2]);
      GotoXY(WhereX,WhereY-2); {damit das nchste Zeichen folgen kann}
    end;
    else GotoXY(WhereX + 3,WhereY);
  end;
end;


end. {no Inits}

